#include <iostream>
#include <cstdlib>
#include <ctime>
#include "binaryHeap.h"
using namespace std;

void quickSort(int myArray[], int start, int end);
int partition(int set[], int start, int end);

void swap(int &value1, int &value2);
void mergeSort(int myArray[], int size);
void merge(int sortedArray[], int size, int leftArray[], int leftSize, int rightArray[], int rightSize);

int main() {
	unsigned startTime, endTime, seedValue;
	int count, numberOfElements, index;

	cout << "Enter the number of elements to use: ";
	cin >> numberOfElements;
	BinaryHeap<int> myHeap(numberOfElements);
	int * myArray = new int [numberOfElements];
	
	cout << "\n====================================================" << endl;
	seedValue = 10;
	srand(seedValue);

	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myHeap.insert(rand());
	} // end for
	for (index = 0; index < numberOfElements; index++) {
		myArray[index] = myHeap.delMin();
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Binary Heap fill time of " << numberOfElements << " random elements plus sort time took " 
		<< endTime - startTime << " seconds." << endl;	

	cout << "Heap sort results: ";
	for (index = 0; index < numberOfElements; index++) {
		cout << myArray[index]<< " ";
	} // end for
	cout << endl;

	cout << "\n====================================================" << endl;
	seedValue = 10;
	srand(seedValue);

	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myArray[count] = rand();
	} // end for

	mergeSort(myArray, numberOfElements);

	endTime = static_cast<unsigned>(time(0));
	cout << "Merge Sort fill time of " << numberOfElements << " elements plus sort time took " 
		<< endTime - startTime << " seconds." << endl;	

	cout << "Merge sort results: ";
	for (index = 0; index < numberOfElements; index++) {
		cout << myArray[index]<< " ";
	} // end for
	cout << endl;


	cout << "\n====================================================" << endl;
	seedValue = 10;
	srand(seedValue);

	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myArray[count] = rand();
	} // end for

	quickSort(myArray, 0, numberOfElements-1);

	endTime = static_cast<unsigned>(time(0));
	cout << "Quick Sort fill time of " << numberOfElements << " elements plus sort time took " 
		<< endTime - startTime << " seconds." << endl;	

	cout << "Quick sort results: ";
	for (index = 0; index < numberOfElements; index++) {
		cout << myArray[index]<< " ";
	} // end for
	cout << endl;

} // end main

void quickSort(int myArray[], int start, int end) {

	// ADD CODE HERE FOR PART B

} // end quickSort

int partition(int set[], int start, int end) {
	int pivotValue, pivotIndex, mid;
	mid = (start + end) / 2;
	swap(set[start], set[mid]);
	pivotIndex = start;
	pivotValue = set[start];
	for (int scan = start + 1; scan <= end; scan++) {
		if (set[scan] < pivotValue) {
			pivotIndex++;
			swap(set[pivotIndex], set[scan]);
		} // end if
	}// end for
	swap(set[start], set[pivotIndex]);
	return pivotIndex;
} // end partition


// swap simply exchanges the contents of value1 and value2.
void swap(int &value1, int &value2) {
	int temp = value1;
	value1 = value2;
	value2 = temp;
} // end swap

void mergeSort(int myArray[], int size) {

	// ADD CODE HERE FOR PART A

} // end mergeSort

void merge(int sortedArray[], int size, int leftArray[], int leftSize, int rightArray[], int rightSize) {
	int left = 0;
	int right = 0;
	int next = 0;

	while (left < leftSize && right < rightSize) {
		if (leftArray[left] < rightArray[right]) {
			sortedArray[next] = leftArray[left];
			left++;
		} else {
			sortedArray[next] = rightArray[right];
			right++;
		} // end if
		next++;
	} // end while

	while (left < leftSize) {
		sortedArray[next] = leftArray[left];
		left++;
		next++;
	} // end while

	while (right < rightSize) {
		sortedArray[next] = rightArray[right];
		right++;
		next++;
	} // end while

} // end merge